var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React from 'react';
import { Animated, Platform } from 'react-native';
import { BaseButton } from 'react-native-gesture-handler';
var AnimatedBaseButtonTest = Animated.createAnimatedComponent(BaseButton);
var BorderlessButton = /** @class */ (function (_super) {
    __extends(BorderlessButton, _super);
    function BorderlessButton(props) {
        var _this = _super.call(this, props) || this;
        _this._onActiveStateChange = function (active) {
            if (Platform.OS !== 'android') {
                Animated.spring(_this._opacity, {
                    stiffness: 1000,
                    damping: 500,
                    mass: 3,
                    overshootClamping: true,
                    restDisplacementThreshold: 0.01,
                    restSpeedThreshold: 0.01,
                    toValue: active ? _this.props.activeOpacity : 1,
                    useNativeDriver: true,
                }).start();
            }
            _this.props.onActiveStateChange && _this.props.onActiveStateChange(active);
        };
        _this._opacity = new Animated.Value(1);
        return _this;
    }
    BorderlessButton.prototype.render = function () {
        var _a = this.props, children = _a.children, style = _a.style, enabled = _a.enabled, rest = __rest(_a, ["children", "style", "enabled"]);
        return (<AnimatedBaseButtonTest {...rest} onActiveStateChange={this._onActiveStateChange} style={[
            style,
            Platform.OS === 'ios' && enabled && { opacity: this._opacity },
        ]}>
        {children}
      </AnimatedBaseButtonTest>);
    };
    BorderlessButton.defaultProps = {
        activeOpacity: 0.3,
        borderless: true,
    };
    return BorderlessButton;
}(React.Component));
export default BorderlessButton;
