/**
 * TouchableItem renders a touchable that looks native on both iOS and Android.
 *
 * It provides an abstraction on top of TouchableNativeFeedback and
 * TouchableOpacity.
 *
 * On iOS you can pass the props of TouchableOpacity, on Android pass the props
 * of TouchableNativeFeedback.
 */
import React from 'react';
import { ViewStyle, StyleProp, TouchableOpacityProps, TouchableNativeFeedbackProps, GestureResponderEvent, Insets } from 'react-native';
import { BorderlessButtonProps } from './BorderlessButton';
interface TouchableItemProps extends Omit<BorderlessButtonProps, 'activeOpacity' | 'enabled'>, TouchableNativeFeedbackProps, Omit<TouchableOpacityProps, 'activeOpacity'> {
    activeOpacity?: number;
    hitSlop?: Insets;
    borderless: boolean;
    disabled: boolean;
    pressColor: string;
    style: StyleProp<ViewStyle>;
    onPress?: (e: GestureResponderEvent | boolean) => void;
}
export default class TouchableItem extends React.Component<TouchableItemProps> {
    static defaultProps: {
        borderless: boolean;
        pressColor: string;
    };
    render(): React.ReactNode;
}
export {};
