var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
/**
 * TouchableItem renders a touchable that looks native on both iOS and Android.
 *
 * It provides an abstraction on top of TouchableNativeFeedback and
 * TouchableOpacity.
 *
 * On iOS you can pass the props of TouchableOpacity, on Android pass the props
 * of TouchableNativeFeedback.
 */
import React from 'react';
import { Platform, View, } from 'react-native';
import { TouchableNativeFeedback, TouchableOpacity, } from 'react-native-gesture-handler';
import BorderlessButton from './BorderlessButton';
var ANDROID_VERSION_LOLLIPOP = 21;
var TouchableItem = /** @class */ (function (_super) {
    __extends(TouchableItem, _super);
    function TouchableItem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TouchableItem.prototype.render = function () {
        /*
         * TouchableNativeFeedback.Ripple causes a crash on old Android versions,
         * therefore only enable it on Android Lollipop and above.
         *
         * All touchables on Android should have the ripple effect according to
         * platform design guidelines.
         * We need to pass the background prop to specify a borderless ripple effect.
         */
        if (Platform.OS === 'android' &&
            Platform.Version >= ANDROID_VERSION_LOLLIPOP) {
            var _a = this.props, style = _a.style, rest = __rest(_a, ["style"]);
            return (<TouchableNativeFeedback {...rest} style={null} background={{
                type: 'Ripple',
                color: this.props.pressColor,
                borderless: this.props.borderless,
            }}>
          <View style={style}>{React.Children.only(this.props.children)}</View>
        </TouchableNativeFeedback>);
        }
        else if (Platform.OS === 'ios') {
            return (<BorderlessButton hitSlop={{ top: 10, bottom: 10, right: 10, left: 10 }} disallowInterruption enabled={!this.props.disabled} {...this.props}>
          {this.props.children}
        </BorderlessButton>);
        }
        else {
            return (<TouchableOpacity {...this.props}>
          {this.props.children}
        </TouchableOpacity>);
        }
    };
    TouchableItem.defaultProps = {
        borderless: false,
        pressColor: 'rgba(0, 0, 0, .32)',
    };
    return TouchableItem;
}(React.Component));
export default TouchableItem;
